/*
Author:	Bindesh Kumar Singh
Begin:	25 March, 2007
Finish:	26 March, 2007
About:	This is a filename string replacer. It searches
the files and replaces target strings with the user
specified strings.
COMPILER:	VC++ 6.0
*/

#include <windows.h>
#include "resource.h"

/* MACROS */
#define BEEP MessageBeep(1)
#define ISCHECKED(ID_OF_BUTTON) (IsDlgButtonChecked(hdlg,ID_OF_BUTTON)==BST_CHECKED)
/*  GLOBAL VARIABLES	*/
int numfiles;

/*    FUNCTIONS     */
BOOL CALLBACK dlgproc(HWND ,UINT ,WPARAM ,LPARAM );
int strrepstr(char*,const char*,const char*);

/********************/
int WINAPI WinMain(HINSTANCE hinst,HINSTANCE hprevinst,LPSTR cmdline, int ncmdshow)
{
	numfiles = 0;
	DialogBox(hinst,MAKEINTRESOURCE(IDD_DIALOG),0,(DLGPROC)dlgproc);
	return 0L;
}

BOOL CALLBACK dlgproc(HWND hdlg,UINT msg,WPARAM wparam,LPARAM lparam)
{
	static OPENFILENAME ofn;
	TCHAR filename[MAX_PATH],target[256],source[256];
	HANDLE hfile = 0;
	static WIN32_FIND_DATA finddata;
	BOOL searchactive = 1;
	TCHAR *pstrn = NULL;
	int pos = 0;
	filename[0] = 0;

	switch(msg)
	{
	case WM_COMMAND:
		switch(LOWORD(wparam))
		{
		case IDC_BUTTON_EXIT:
			if(IDNO == MessageBox(hdlg,TEXT("Click ok to exit"),TEXT("Do you want to exit?"),MB_YESNO) )
				return TRUE;
			EndDialog(hdlg,0);
			break;

		case IDC_BUTTON_ABOUT:
			MessageBox(hdlg,TEXT("Developed by Bindesh Kumar Singh.\nMail me at: bindesh_softwaretalk@yahoo.co.in\nVisit: www.ourinnovativemind.blogspot.com"),TEXT("Bindesh kumar Singh"),0);
			break;

		case IDC_BUTTON_DOIT:
			{
				TCHAR strmsg[56];
				ZeroMemory(&finddata,sizeof(finddata));
				ZeroMemory(filename,sizeof(filename));
				ZeroMemory(source,sizeof(source));
				ZeroMemory(target,sizeof(target));
				GetDlgItemText(hdlg,IDC_EDIT_PATH,filename,MAX_PATH-1);
				if(! lstrlen(filename))
				{
					MessageBox(hdlg,TEXT("Please select a file via select button"),TEXT("No target selected"),0);
					return TRUE;
				}
				GetDlgItemText(hdlg,IDC_EDIT_TARGET,target,MAX_PATH-1);
				if(! lstrlen(target))
				{
					MessageBox(hdlg,TEXT("Please enter replace string"),TEXT("Replace string not selected"),0);
					return TRUE;
				}
				GetDlgItemText(hdlg,IDC_EDIT_SOURCE,source,sizeof(source));
				if(!lstrlen(source))
					MessageBox(hdlg,TEXT("Replace-with string not entered"),TEXT("Info"),0);
			
				if(!strstr(filename,"\\*") )
					strcat(filename,"\\*");
				MessageBox(hdlg,filename,finddata.cFileName,0);
//				return 0;
				strcat(filename,target);
				strcat(filename,"*.*");
				numfiles = 0;
				hfile = FindFirstFile(filename,&finddata);
				searchactive = FindNextFile(hfile,&finddata);
				if(searchactive)
					MessageBox(hdlg,filename,finddata.cFileName,0);
				while(searchactive)
				{
					strcpy(filename,finddata.cFileName);
					while(strrepstr(filename,target,source));
					if(MoveFile(finddata.cFileName,filename))
						numfiles++;
					searchactive = FindNextFile(hfile,&finddata);

				}
				wsprintf(strmsg,"%d files/folders renamed successfully",numfiles);
				MessageBox(hdlg,strmsg,TEXT("Done"),0);
			}
			break;

		case IDC_BUTTON_BROWSE:
			{
				TCHAR fullpath[MAX_PATH],fname[MAX_PATH],fileext[128];
				fullpath[0] = fileext[0] = fname[0] = 0;
				ZeroMemory(&finddata,sizeof(finddata));
				ZeroMemory(fname,sizeof(fname));
				ZeroMemory(source,sizeof(source));
				ZeroMemory(target,sizeof(target));
			/* OPENFILENAME structure	*/
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hdlg;
			ofn.lpstrFilter = TEXT("Select any file\0*.*\0");
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = fullpath;
			ofn.nMaxFile = sizeof(fullpath);
			ofn.lpstrFileTitle = fname;
			ofn.nMaxFileTitle = sizeof(fname);
			ofn.lpstrTitle = TEXT("Open file");
			ofn.Flags = OFN_CREATEPROMPT | OFN_EXPLORER |
				OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
			
			if(!GetOpenFileName(&ofn))
				return TRUE;
			ofn.lpstrFile[ofn.nFileOffset]=0;
/*			if(GetDlgItemText(hdlg,IDC_EDIT_EXT,fileext,sizeof(fileext)) && ISCHECKED(IDC_CHECK_EXT))
			{
				lstrcat(fullpath,"*.");
				lstrcat(fullpath,fileext);
			}
			else
*/			lstrcat(fullpath,"*");
			SetDlgItemText(hdlg,IDC_EDIT_PATH,fullpath);
			}
			break;

		case IDC_CHECK_DELCOPY:
			if(ISCHECKED(IDC_CHECK_DELCOPY))
			{
				SetDlgItemText(hdlg,IDC_STATIC_SOURCE,TEXT("Copy to path:"));
				EnableWindow(GetDlgItem(hdlg,IDC_BUTTON_DOIT),FALSE);
			}
			else
			{
				SetDlgItemText(hdlg,IDC_STATIC_SOURCE,TEXT("Replace with"));
				EnableWindow(GetDlgItem(hdlg,IDC_BUTTON_DOIT),TRUE);
			}

			break;

		case IDC_BUTTON_COPY:
			if(! ISCHECKED(IDC_CHECK_DELCOPY))
				break;
			memset(&finddata,0,sizeof(finddata));
			memset(filename,0,sizeof(filename));
			memset(source,0,sizeof(source));
			memset(target,0,sizeof(target));
			GetDlgItemText(hdlg,IDC_EDIT_PATH,filename,sizeof(filename));
			if(! lstrlen(filename))
			{
				MessageBox(hdlg,TEXT("Please select a file via select button"),TEXT("No target selected"),0);
				return TRUE;
			}

			GetDlgItemText(hdlg,IDC_EDIT_TARGET,target,sizeof(target));
			if(!strlen(target))
			{
				MessageBox(hdlg,TEXT("Enter a search string."),TEXT("EMPTY FIELD"),0);
				return TRUE;
			}

			GetDlgItemText(hdlg,IDC_EDIT_SOURCE,source,sizeof(source));
			if(!strlen(source))
			{
				MessageBox(hdlg,TEXT("Enter the path to copy these files with selected string."),TEXT("EMPTY FIELD"),0);
				if(IDOK != MessageBox(hdlg,TEXT("Click OK to copy files in same folder\nwith COPY_"),TEXT("Use same folder"),0))
					return TRUE;
				strcpy(source,"COPY_");
			}
			else
			{
				switch(GetDriveType(source))
				{
				case DRIVE_UNKNOWN:
					MessageBox(hdlg,TEXT("Drive invalid"),TEXT("Drive unknown"),0);
					return TRUE;

				case DRIVE_NO_ROOT_DIR:
					MessageBox(hdlg,TEXT("The root directory does not exist."),TEXT("ROOT invalid"),0);
					return TRUE;

				case DRIVE_REMOTE:
					MessageBox(hdlg,TEXT("The drive is a remote (network) drive"),TEXT("Network drive found"),0);
					return TRUE;
						
				case DRIVE_CDROM:
					MessageBox(hdlg,TEXT("The drive is a CD-ROM drive"),TEXT("NON-MAGNETIC MEDIA"),0);
					return TRUE;

				case DRIVE_RAMDISK:
					MessageBox(hdlg,TEXT("The drive is a RAM disk"),TEXT("RAMDISK"),0);
					return TRUE;
				
				case DRIVE_REMOVABLE:
				case DRIVE_FIXED:
					break;
				}
			}
			pos = strlen(source);
			strcat(filename,target);
			strcat(filename,"*.*");
			hfile = FindFirstFile(filename,&finddata);
			searchactive = FindNextFile(hfile,&finddata);
			
			while(searchactive)
			{
				searchactive = FindNextFile(hfile,&finddata);
				strcat(source,finddata.cFileName);
				CopyFile(finddata.cFileName,source,TRUE);
				source[pos]=0;
			}
			MessageBox(hdlg,TEXT("Files copied successfully"),TEXT("Done"),0);
			break;

		case IDC_BUTTON_DELETE:
			if(! ISCHECKED(IDC_CHECK_DELCOPY))
				break;
			memset(&finddata,0,sizeof(finddata));
			memset(filename,0,sizeof(filename));
			memset(source,0,sizeof(source));
			memset(target,0,sizeof(target));
			GetDlgItemText(hdlg,IDC_EDIT_PATH,filename,sizeof(filename));
			if(! lstrlen(filename))
			{
				MessageBox(hdlg,TEXT("Please select a file via select button"),TEXT("No target selected"),0);
				return TRUE;
			}

			GetDlgItemText(hdlg,IDC_EDIT_TARGET,target,sizeof(target));
			if(!strlen(target))
			{
				MessageBox(hdlg,TEXT("Enter a search string."),TEXT("EMPTY FIELD"),0);
				return TRUE;
			}
			pos = strlen(source);
			strcat(filename,target);
			strcat(filename,"*.*");
			hfile = FindFirstFile(filename,&finddata);
			searchactive = FindNextFile(hfile,&finddata);
			while(searchactive)
			{
				searchactive = FindNextFile(hfile,&finddata);
				strcat(source,finddata.cFileName);
				if(! DeleteFile(finddata.cFileName))
				{
					RemoveDirectory(finddata.cFileName);
				}
				source[pos]=0;
			}
			MessageBox(hdlg,TEXT("Files Deleted successfully"),TEXT("Done"),0);
			break;

		}
	

	}

	return FALSE;
}

int strrepstr(char* txt,const char *r,const char *rw)
{
 char* pchdest = NULL;
 char temp[1024];

 memset(temp,0,sizeof(temp));
 pchdest = strstr(txt,r);
 if(!pchdest)
	return 0;
 strncpy(temp,txt,pchdest-txt);
 strcat(temp,rw);
 strcat(temp,pchdest+strlen(r));
 strcpy(txt,temp);
 return 1;
}